package jp.co.gihyo.webdb.vol35.tdd.webapp.rest.impl;

import jp.co.gihyo.webdb.vol35.tdd.webapp.rest.EntityRequestRetriever;

import org.seasar.extension.unit.S2TestCase;
import org.seasar.framework.aop.interceptors.MockInterceptor;
import org.seasar.framework.mock.servlet.MockHttpServletRequest;

public class EntityRequestRetrieverComponentTest extends
        S2TestCase {
    EntityRequestRetriever entityRequestRetriever;
    MockInterceptor sampleDaoMock;

    public void setUp() throws Exception {
        include("EntityRequestRetrieverComponentTest.dicon");
    }

    public void testHttpServletRequest̓eƂDaoĂяos()
            throws Exception {

        // S2Unit񋟂郂bN̂܂܎g
        MockHttpServletRequest mockRequest = getRequest();
        
        mockRequest.setPathInfo("/sample/100");
        SampleEntity entity =
            (SampleEntity) entityRequestRetriever
                .retrieveEntityFor(mockRequest);

        assertNotNull(entity);
        assertEquals(100, entity.getId());
        assertEquals("Higa", entity.getName());

        assertTrue(sampleDaoMock.isInvoked("getById"));
        Object[] actualArgs =
            sampleDaoMock.getArgs("getById");
        assertEquals(new Long(100), actualArgs[0]);
    }
}
